# -*- coding: utf-8 -*-
import client.extraClientApi as clientApi
ViewBinder = clientApi.GetViewBinderCls()
ViewRequest = clientApi.GetViewViewRequestCls()
ScreenNode = clientApi.GetScreenNodeCls()


class UIAnimationScreen(ScreenNode):
	def __init__(self, namespace, name, param):
		ScreenNode.__init__(self, namespace, name, param)
		self.animationPathList = [
			"/alphaImg", "/clipImg", "/colorImg", "/flipbookImg", "/offsetImg", "/sizeImg", "/uvImg"
		]
		self.animationUIControlList = []
		self.alphaBtn = None
		self.clipBtn = None
		self.colorBtn = None
		self.flipbookBtn = None
		self.offsetBtn = None
		self.sizeBtn = None
		self.uvBtn = None
		self.closeBtn = None
		self.resetBtn = None
		self.curShowIndex = 0

	def Create(self):
		self.alphaBtn = self.GetBaseUIControl("/alphaBtn").asButton()
		self.clipBtn = self.GetBaseUIControl("/clipBtn").asButton()
		self.colorBtn = self.GetBaseUIControl("/colorBtn").asButton()
		self.flipbookBtn = self.GetBaseUIControl("/flipbookBtn").asButton()
		self.offsetBtn = self.GetBaseUIControl("/offsetBtn").asButton()
		self.sizeBtn = self.GetBaseUIControl("/sizeBtn").asButton()
		self.uvBtn = self.GetBaseUIControl("/uvBtn").asButton()
		self.closeBtn = self.GetBaseUIControl("/closeBtn").asButton()
		self.resetBtn = self.GetBaseUIControl("/resetBtn").asButton()
		self.alphaBtn.AddTouchEventParams()
		self.alphaBtn.SetButtonTouchUpCallback( lambda args: self.OnItemClick(0, args))
		self.clipBtn.AddTouchEventParams()
		self.clipBtn.SetButtonTouchUpCallback( lambda args: self.OnItemClick(1, args))
		self.colorBtn.AddTouchEventParams()
		self.colorBtn.SetButtonTouchUpCallback( lambda args: self.OnItemClick(2, args))
		self.flipbookBtn.AddTouchEventParams()
		self.flipbookBtn.SetButtonTouchUpCallback( lambda args: self.OnItemClick(3, args))
		self.offsetBtn.AddTouchEventParams()
		self.offsetBtn.SetButtonTouchUpCallback( lambda args: self.OnItemClick(4, args))
		self.sizeBtn.AddTouchEventParams()
		self.sizeBtn.SetButtonTouchUpCallback( lambda args: self.OnItemClick(5, args))
		self.uvBtn.AddTouchEventParams()
		self.uvBtn.SetButtonTouchUpCallback( lambda args: self.OnItemClick(6, args))
		self.closeBtn.AddTouchEventParams()
		self.closeBtn.SetButtonTouchUpCallback(self.onCloseBtnClick)
		self.resetBtn.AddTouchEventParams()
		self.resetBtn.SetButtonTouchUpCallback(self.onResetBtnClick)
		for animationPath in self.animationPathList:
			self.animationUIControlList.append(self.GetBaseUIControl(animationPath))

	def onCloseBtnClick(self, args):
		self.SetRemove()

	def onResetBtnClick(self, args):
		self.animationUIControlList[self.curShowIndex].resetAnimation()

	def OnItemClick(self, index, args):
		self.curShowIndex = index
		for i, animationUIControl in enumerate(self.animationUIControlList):
			animationUIControl.SetVisible(i == self.curShowIndex, False)
		self.UpdateScreen(True)
		self.onResetBtnClick({})
			
